/*
	SourceMod Anti-Cheat Eye Test Module
	Copyright (C) 2011 GoD-Tony
	Copyright (C) 2011 Nicholas "psychonic" Hastings (nshastings@gmail.com)
	Copyright (C) 2007-2011 CodingDirect LLC

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//- Global Variables -//

new bool:g_bEyeEnabled = false;
new Handle:g_hEyeTimer = INVALID_HANDLE;
new Handle:g_hCVarEyeEnable = INVALID_HANDLE;

//- Plugin Functions -//

Eyetest_OnPluginStart()
{
	if ( g_Game != Game_INS && g_Game != Game_CSS && g_Game != Game_L4D2 && g_Game != Game_HL2DM )
	{
		g_hCVarEyeEnable = CreateConVar("smac_eyes_enable", "0", "Enable the eye test detection routine.");
		Eyetest_EnableChange(g_hCVarEyeEnable, "", "");

		HookConVarChange(g_hCVarEyeEnable, Eyetest_EnableChange);
	}
}

//- Timer -//

public Action:Eyetest_Timer(Handle:timer, any:we)
{
	if ( !g_bEyeEnabled )
	{
		g_hEyeTimer = INVALID_HANDLE;
		return Plugin_Stop;
	}

	decl Float:f_vAngles[3], Float:f_fX, Float:f_fZ, String:f_sAuthID[64], String:f_sIP[64];
	for(new i=1;i<=MaxClients;i++)
	{
		if ( g_bConnected[i] && g_bInGame[i] && IsPlayerAlive(i) && GetClientEyeAngles(i, f_vAngles) )
		{
			f_fX = f_vAngles[0];
			f_fZ = f_vAngles[2];
			if ( f_fX > 180.0 )
				f_fX -= 360.0;
			if ( f_fZ > 180.0 )
				f_fZ -= 360.0;
			if ( f_fX > 90.0 || f_fX < -90.0 || f_fZ > 90.0 || f_fZ < -90.0 )
			{	
				GetClientAuthString(i, f_sAuthID, sizeof(f_sAuthID));
				GetClientIP(i, f_sIP, sizeof(f_sIP));
				SMAC_Log("%N (ID: %s | IP: %s) was banned for cheating with their eye angles.  Eye Angles: %f %f %f", i, f_sAuthID, f_sIP, f_fX, f_vAngles[1], f_fZ);
				SMAC_Ban(i, 0, SMAC_BANNED, "SMAC: Eye Angles Violation");
			}
		}
	}
	return Plugin_Continue;
}

public Eyetest_EnableChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	g_bEyeEnabled = GetConVarBool(convar);
	if ( g_bEyeEnabled && g_hEyeTimer == INVALID_HANDLE )
	{
		g_hEyeTimer = CreateTimer(0.5, Eyetest_Timer, _, TIMER_REPEAT);
	}
	else if ( !g_bEyeEnabled && g_hEyeTimer != INVALID_HANDLE )
	{
		CloseHandle(g_hEyeTimer);
		g_hEyeTimer = INVALID_HANDLE;
	}
}
